=== debian/changelog ===
ulfius (2.6.9-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add patch to skip 3 tests, new and already disabled in previous versions.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 05 Sep 2020 13:28:20 +0200

ulfius (2.6.9-1) unstable; urgency=medium

  * New upstream release
  * d/control: Remove dh-exec from builddep
  * d/upstream/metadata: Drop duplicate Repository field
  * d/libulfius2.6.symbols: add new symbols

 -- Nicolas Mora <babelouest@debian.org>  Fri, 04 Sep 2020 20:06:59 -0400

ulfius (2.6.8-1ubuntu1) groovy; urgency=medium

  * Add patch to skip 3 tests, new and already disabled in previous versions.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 12 Jul 2020 21:05:49 +0200

ulfius (2.6.8-1) unstable; urgency=medium

  * New upstream release (Closes: #964384)
  * d/patches: re-enable failing test in test/framework.c
  * d/uwsc: remove manpage from debian, install upstream page
  * d/patches: disable test_core.patch because libmicrohttpd 0.9.71 fixes the
    issue mentioned in 2.6.7-2
  * d/patches: disable test_framework.patch, now applied upstream

 -- Nicolas Mora <babelouest@debian.org>  Thu, 09 Jul 2020 20:32:53 -0400

ulfius (2.6.7-4) unstable; urgency=medium

  * d/patches: add workaround patch for mips lack of support for setsockopt
    SO_REUSEPORT option

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 01 Jul 2020 08:35:05 -0400

ulfius (2.6.7-3) unstable; urgency=medium

  * d/rules: avoid downloading dependencies if not found
  * d/rules: display ctest error on failure
  * rename uwsc manpage to uwsc.1

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 30 Jun 2020 19:59:01 -0400

ulfius (2.6.7-2) unstable; urgency=medium

  * Upload to unstable
  * d/rules: run tests manually to override arg -j4
  * d/patches: disable test patch
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * d/patches/test_core.patch: disable failing test (remove when the test
    will be fixed upstream)

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 28 Jun 2020 09:53:17 -0400

ulfius (2.6.7-1) experimental; urgency=medium

  * New upstream release
  * d/copyright: cleanup
  * d/control: add Rules-Requires-Root
  * d/control: use debhelper-compat
  * d/control: set debhelper-control version to 13

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 04 Jun 2020 07:22:11 -0400

ulfius (2.6.6-1) experimental; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.5.0 (no changes)
  * debian/copyright: fix copyright issues
  * d/rules: generate doc using doxygen
  * d/libulfius-dev.docs: install documentation
  * d/patches: Fix doxygen privacy issues

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 03 Apr 2020 19:55:38 -0400

ulfius (2.5.2-4) unstable; urgency=medium

  * debian/rules: remove override_dh_auto_test since now it's executed
    automatically
  * debian/control: Add 'Multi-Arch: same' for libulfius2.5 and
    libulfius-dev
  * debian/patches: Fix shlibs warning
  * Fix uwsc version in man page
  * debian/control: Remove autopkgtest from Build-Depends

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 12 Jan 2019 12:41:47 -0500

ulfius (2.5.2-3) unstable; urgency=medium

  * debian/tests/control: fix autopkgtest dependencies
  * debian/rules: clarify dh_auto_configure to explicitly declare options
                  build tests from cmake instead of Makefile
  * debian/control: upgrade Standards-Version to current 4.3.0 (no change)
  * debian/control: add missing dependencies to libulfius-dev package
  * debian/control: explicitly add libgnutls28-dev to build dependencies
  * debian/patches/test.diff: fix unit test random crash
  * debian/patches/*: remove obsolete patches

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 05 Jan 2019 10:32:18 -0500
