=== debian/control ===
Source: ulfius
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
          , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , libmicrohttpd-dev
             , libcurl4-gnutls-dev
             , libgnutls28-dev
             , libjansson-dev
             , liborcania-dev
             , libyder-dev
             , cmake
             , pkg-config
             , check
             , gnutls-bin
             , doxygen
Standards-Version: 4.5.0
Homepage: https://github.com/babelouest/ulfius
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
Rules-Requires-Root: no

Package: libulfius2.6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Web Framework for REST Applications in C
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or
 implement server websockets.

Package: libulfius-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libulfius2.6 (= ${binary:Version})
       , ${misc:Depends}
       , libmicrohttpd-dev
       , libcurl4-gnutls-dev
       , libgnutls28-dev
       , libjansson-dev
       , liborcania-dev
       , libyder-dev
       , libjs-jquery
Description: Web Framework for REST Applications in C - development
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or
 implement server websockets.
 .
 This package contains the development files.

Package: uwsc
Architecture: any
Depends: ${shlibs:Depends},
       , libulfius2.6 (= ${binary:Version})
       , ${misc:Depends}
Description: Ulfius WebSocket Client
 Simple command-line application to connect to websocket services
 .
 Can connect to websocket services, both ws:// (http) or wss:// (https).
 When the websocket is connected, messages from the server are displayed
 in the terminal and messages can be sent to the service via a prompt >.
