=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, gnutls-bin, libc-dev, liborcania-dev, libyder-dev, check, libsubunit-dev, pkg-config
