## ulfius 2.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,8 +29,8 @@
 set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/ulfius/")
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/ulfius/issues")
 set(LIBRARY_VERSION_MAJOR "2")
-set(LIBRARY_VERSION_MINOR "6")
-set(LIBRARY_VERSION_PATCH "9")
+set(LIBRARY_VERSION_MINOR "7")
+set(LIBRARY_VERSION_PATCH "1")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -154,6 +154,12 @@
 
 if (WITH_WEBSOCKET)
     set(U_DISABLE_WEBSOCKET OFF)
+    include(FindZLIB)
+    find_package(ZLIB REQUIRED)
+    if (ZLIB_FOUND)
+        set(LIBS ${LIBS} ${ZLIB_LIBRARIES})
+        include_directories(${ZLIB_INCLUDE_DIRS})
+    endif ()
 else ()
     set(U_DISABLE_WEBSOCKET ON)
 endif ()
@@ -377,9 +383,3 @@
         
         set(TESTS core u_map framework)
         if (WITH_WEBSOCKET)
-            set(TESTS ${TESTS} websocket)
-        endif ()
-
-        configure_file(
-                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
-                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
