=== debian/changelog ===
ulfius (2.7.1-1+deb11u2) bullseye; urgency=medium

  * d/patches: Uses o_malloc instead of malloc (Closes: #1001384)

 -- Nicolas Mora <babelouest@debian.org>  Thu, 09 Dec 2021 08:06:15 -0500

ulfius (2.7.1-1+deb11u1) bullseye; urgency=medium

  * d/patches: Fix CVE-2021-40540 (Closes: #994763)

 -- Nicolas Mora <babelouest@debian.org>  Sun, 19 Sep 2021 15:39:39 -0400

ulfius (2.7.1-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sun, 03 Jan 2021 09:03:05 -0500

ulfius (2.7.0-3) unstable; urgency=medium

  * d/control: add libulfius-dev dependency zlib1g-dev (Closes: #977348)

 -- Nicolas Mora <babelouest@debian.org>  Mon, 14 Dec 2020 10:57:51 -0500

ulfius (2.7.0-2) unstable; urgency=medium

  * d/control: add breaks/replaces libulfius2.6, libulfius2.5

 -- Nicolas Mora <babelouest@debian.org>  Sat, 12 Dec 2020 08:13:38 -0500

ulfius (2.7.0-1) unstable; urgency=medium

  * New upstream release
  * d/control: bump standard to 4.5.1 (no changes)
  * d/control: Add zlib1g as build dep

 -- Nicolas Mora <babelouest@debian.org>  Mon, 07 Dec 2020 19:44:11 -0500
