=== debian/control ===
--- 
+++ 
@@ -16,13 +16,16 @@
              , check
              , gnutls-bin
              , doxygen
-Standards-Version: 4.5.0
+             , zlib1g-dev
+Standards-Version: 4.5.1
 Homepage: https://github.com/babelouest/ulfius
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
 Rules-Requires-Root: no
 
-Package: libulfius2.6
+Package: libulfius2.7
+Replaces: libulfius2.6, libulfius2.5
+Breaks: libulfius2.6, libulfius2.5
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -41,7 +44,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libulfius2.6 (= ${binary:Version})
+Depends: libulfius2.7 (= ${binary:Version})
        , ${misc:Depends}
        , libmicrohttpd-dev
        , libcurl4-gnutls-dev
@@ -50,6 +53,7 @@
        , liborcania-dev
        , libyder-dev
        , libjs-jquery
+       , zlib1g-dev
 Description: Web Framework for REST Applications in C - development
  Based on GNU Libmicrohttpd for the backend web server, Jansson for the
  json manipulation library, and Libcurl for the http/smtp client API.
@@ -65,7 +69,7 @@
 Package: uwsc
 Architecture: any
 Depends: ${shlibs:Depends},
-       , libulfius2.6 (= ${binary:Version})
+       , libulfius2.7 (= ${binary:Version})
        , ${misc:Depends}
 Description: Ulfius WebSocket Client
  Simple command-line application to connect to websocket services
